#!/bin/sh

# create channelmap.conf for epg-daemon from VDR channels.conf

CHANNELS_CONF="/etc/vdr/channels.conf"
EPGDID_LIST="/etc/epgd/channelmap-ids.csv"
CHANNEL_MAP="/etc/epgd/channelmap.conf"
EPGD_CONF="/etc/epgd/epgd.conf"

if [ ! -e $CHANNELS_CONF ]; then
  echo "$CHANNELS_CONF not found!"
  exit
fi

first=$(setting get -d tvm epgDaemon.first)
second=$(setting get -d tvsp epgDaemon.second)
add_tvm=$($(setting get -d true epgDaemon.tvm) && [ "$first" = 'tvm' -o $second = 'tvm' ] && echo true || echo false)
add_tvsp=$($(setting get -d true epgDaemon.tvsp) && [ "$first" = 'tvsp' -o $second = 'tvsp' ] && echo true || echo false)
add_epgdata=$($(setting get -d true epgDaemon.epgdata) && grep -q "^epgdata.pin = .\{41\}$" $EPGD_CONF 2>/dev/null && [ "$first" = 'epgdata' -o $second = 'epgdata' ] && echo true || echo false)
add_vdr=$(setting get -d false epgDaemon.vdr)
sec_tvm=$([ $second = 'tvm' ] && echo ":2")
sec_tvsp=$([ $second = 'tvsp' ] && echo ":2")
sec_epgdata=$([ $second = 'epgdata' ] && echo ":2")


cut -d":" -f1,4,10,11,12 $CHANNELS_CONF | sed '/^$/d' | sed '/^\./d' | while IFS=: read -r a b c d e; do
  vdrname="$(echo "$a" | cut -d ";" -f1 | cut -d "," -f1)"
  chanid="$b-$d-$e-$c"

  found=false
  IFS=, read tvmid epgdataid tvspid <<< $(grep -i "'$vdrname'" $EPGDID_LIST | cut -d "," -f 2,4,6)

  echo "// $vdrname"
  if $add_tvm && [ "$tvmid" ]; then
    echo "tvm:$tvmid$sec_tvm = $chanid"
    found=true
  fi
  if $add_tvsp && [ "$tvspid" ]; then
    echo "tvsp:$tvspid$sec_tvsp = $chanid"
    found=true
  fi
  if $add_epgdata && [ "$epgdataid" ]; then
    echo "epgdata:$epgdataid$sec_epgdata = $chanid"
    found=true
  fi
  if $add_vdr || ! $found; then
    echo "vdr:000:0:0 = $chanid"
  fi
done > $CHANNEL_MAP
